program main

  use file_operate
  use Thermo_Const
  use Thermo_Function
  use Thermo_Advanced_Routine
  use Math_Const
  use Phys_Const
  use basis
  use Statistics
  use Typhoon_Analy
  use Max_min

!-- ؤ˽簵ήä۲ǡץ.
!--  (1) ʿήαľϥ,
!--  (2) ưϽవ, 
!--  (3) ʿήϹήХ.
!-- ΤȤ, ưϰϺɸ fk\times u = -g\nabla z,
!-- 弰դϰͤʤΤ, Ϳʿή®٤
!-- ̤Ǥιʬۤ
!-- z(x,y) = z_0 + (f/g) [v(x-x_0)-u(y-y_0)].
!-- z_0 ϴ, x_0, y_0 Ϥι٤Ȥ.
!-- ΤȤ, ή줬簵Ǥ뤿, ̹پǤ٤Ȥʤ.
!-- ܥץ Peng et al (1999) ˤ.

  use sub_mod
  implicit none
  integer :: i, j, k, nl, nc, irz, ip

  real, parameter :: undefs=-999.0, undefc=-1.0e35
  real :: dx, dy, dz  ! x, y, z γʻֳ [m]
  real :: xc, yc
  real :: rmax  ! region distance from center
  real :: cor   ! coriolis parameter
  real :: alp  ! normalized coefficient of pressure
  real :: bm0, bm1, bm2, bm3, gam, a2m, b2m, xm2, xm, x0, vmrm, vm2
  real, allocatable, dimension(:) :: x, y    ! ǥȺɸ׻
  real, allocatable, dimension(:) :: xd, yd  ! ǥȺɸϿ
  real, allocatable, dimension(:) :: rz  ! ɸ
  real, allocatable, dimension(:) :: GP  ! ʲϺɸ
  real, allocatable, dimension(:) :: tempbar, qvbar, vr0, a1, b1
  real, allocatable, dimension(:,:) :: r, theta  ! ɸ
  real, allocatable, dimension(:,:) :: vrz, zr, tempz  ! ɸ
  real, allocatable, dimension(:,:) :: sonde_val  ! sounding value
  real, allocatable, dimension(:,:,:) :: u, v, p, temp, rh, vr, z
        ! 줾, , ľ, , , RH, ®,  (MKS)
  real, allocatable, dimension(:,:,:) :: dpdx, dpdy
  real, allocatable, dimension(:,:,:) :: pbar

  character(100), allocatable, dimension(:,:) :: tmp_val  ! եɤ߽Ф

!-- namelist values
  integer :: nx, ny, nz, nr
  integer :: skip_num
  real :: xmin, xmax, ymin, ymax, zmin, zmax
  real :: r0, plim, RMW, cent_lat, ubar, bt, vmax
  character(100) :: sounding_name, output_name, read_colum
  character(5), dimension(4) :: unit_flag

!-- reading namelist

  namelist /input /xmin, ymin, zmin, xmax, ymax, zmax, nx, ny, nz, nr
  namelist /param /r0, plim, RMW, cent_lat, ubar, bt, vmax
  namelist /fread /sounding_name, skip_num, read_colum, unit_flag, output_name

  read(5,nml=input)
  read(5,nml=param)
  read(5,nml=fread)

  write(*,*) "Finished reading namelist."

!-- allocatable

  allocate(x(nx))
  allocate(y(ny))
  allocate(xd(nx))
  allocate(yd(ny))
  allocate(r(nx,ny))
  allocate(theta(nx,ny))
  allocate(u(nx,ny,nz))
  allocate(v(nx,ny,nz))
  allocate(p(nx,ny,nz))
  allocate(temp(nx,ny,nz))
  allocate(rh(nx,ny,nz))
  allocate(z(nx,ny,nz))
  allocate(vr(nx,ny,nz))
  allocate(dpdx(nx,ny,nz))
  allocate(dpdy(nx,ny,nz))
  allocate(pbar(nx,ny,nz))
  allocate(rz(nr))
  allocate(vrz(nr,nz))
  allocate(zr(nr,nz))
  allocate(tempz(nr,nz))
  allocate(tempbar(nz))
  allocate(qvbar(nz))
  allocate(vr0(nr))
  allocate(a1(nr))
  allocate(b1(nr))
  allocate(GP(nr))

!-- parameter setting
  dx=(xmax-xmin)/(nx-1)
  dy=(ymax-ymin)/(ny-1)
  dz=(zmax-zmin)/(nz-1)

  xd=(/((xmin+dx*(i-1)),i=1,nx)/)
  yd=(/((ymin+dy*(i-1)),i=1,ny)/)

  xc=0.5*(xmin+xmax)
  yc=0.5*(ymin+ymax)

  do i=1,nx
     x(i)=xd(i)-xc
  end do
  do i=1,ny
     y(i)=yd(i)-yc
  end do

!-- ꥪѥ᡼׻
  cor=2.0*omega*sin(cent_lat*pi/180.0)

!-- ˺ɸؤѴ
  do j=1,ny
    do i=1,nx 
      r(i,j)=sqrt(x(i)**2+y(j)**2)
    end do
  end do

  do j=1,ny
    do i=1,nx 
      if(x(i)==0.0)then
        if(y(j)==0.0)then
          theta(i,j)=0.0
        else
          if(y(j)<0.0)then
            theta(i,j)=-atan(1.0)*2.0
          else
            theta(i,j)=atan(1.0)*2.0
          end if
        end if
      else
        if(y(j)>0.0)then
          if(x(i)>0.0)then
            theta(i,j)=atan(y(j)/x(i))
          else
            theta(i,j)=atan(1.0)*4.0-atan(abs(y(j)/x(i)))
          end if
        else
          if(x(i)>0.0)then
            theta(i,j)=atan(y(j)/x(i))
          else
            theta(i,j)=-atan(1.0)*4.0+atan(abs(y(j)/x(i)))
          end if
        end if
      end if
    end do
  end do

!-- ٤ν񤭽Ф ---
  do i=1,nz
     do j=1,ny
        do k=1,nx
           z(k,j,i) = zmin+dz*(i-1)
        end do
     end do
  end do

  call max_val_2d( r, j, k, rmax )
  rz=(/((real(i-1)*rmax/real(nr-1)),i=1,nr)/)

  write(*,*) "Finished producing all coordinates."

!-- Ǯϳѿɤ߹ߡʥǥ󥰥ǡΤߡ ---
  nl=line_number_counter( trim(sounding_name) )
  nl=nl-skip_num
  nc=len_trim(adjustl(read_colum))

  allocate(tmp_val(nc,nl))
  allocate(sonde_val(nl,4))

  call read_file_text( trim(sounding_name), nc, nl, tmp_val, skip=skip_num )

!-- ǡ֤ ---

  do k=1,nc
     select case (read_colum(k:k))
     case ('1')  ! ٤
        do j=1,nl
           sonde_val(j,1)=c2r_convert( trim(adjustl(tmp_val(k,j))) )
        end do
     case ('2')  ! 
        do j=1,nl
           sonde_val(j,2)=c2r_convert( trim(adjustl(tmp_val(k,j))) )
        end do
     case ('3')  ! ٤
        do j=1,nl
           sonde_val(j,3)=c2r_convert( trim(adjustl(tmp_val(k,j))) )
        end do
     case ('4')  ! ̤
        do j=1,nl
           sonde_val(j,4)=c2r_convert( trim(adjustl(tmp_val(k,j))) )
        end do
     end select
  end do

!-- ٳʻɬפʥǡ

  !-- , Ǥιٺɸñ̤ m ѴƤ.
  if(trim(unit_flag(1))=='km')then
     do i=1,nl
        sonde_val(i,1)=sonde_val(i,1)*1.0e3
     end do
  end if

  call auto_interpolation_1d( sonde_val(1:nl,1), z(1,1,1:nz),  &
  &                           sonde_val(1:nl,2), p(1,1,1:nz),  &
  &                           undef=undefc, undefr=undefs )  ! 

  call auto_interpolation_1d( sonde_val(1:nl,1), z(1,1,1:nz),  &
  &                           sonde_val(1:nl,3), temp(1,1,1:nz),  &
  &                           undef=undefc, undefr=undefs )  ! 

  call auto_interpolation_1d( sonde_val(1:nl,1), z(1,1,1:nz),  &
  &                           sonde_val(1:nl,4), rh(1,1,1:nz),  &
  &                           undef=undefc, undefr=undefs )  ! 

!-- ñ̤Ĵ (, , ٤ m, Pa, K, %)

  if(trim(unit_flag(2))=='mb'.or.trim(unit_flag(2))=='hPa')then
     do k=1,nz
        if(p(1,1,k)/=undefc)then
           p(1,1,k)=p(1,1,k)*1.0e2
        end if
     end do
  end if

  if(trim(unit_flag(3))=='C')then
     do k=1,nz
        if(temp(1,1,k)/=undefc)then
           temp(1,1,k)=temp(1,1,k)+273.15
        end if
     end do
  end if

  if(trim(unit_flag(4))=='%')then
     do k=1,nz
        if(rh(1,1,k)/=undefc)then
           rh(1,1,k)=RHTP_2_qv( rh(1,1,k), temp(1,1,k), p(1,1,k) )
        end if
     end do
  else if(trim(unit_flag(4))=='gkg')then
     do k=1,nz
        if(rh(1,1,k)/=undefc)then
           rh(1,1,k)=rh(1,1,k)*1.0e-3
        end if
     end do
  end if

  write(*,*) "Finished reading sounding data and converting units."

!-- temporary setting coefficients
  bm0=1.0/bt
  bm1=1.0/(bt-1.0)
  bm2=1.0/(bt-2.0)
  bm3=1.0/(bt-3.0)
  gam=RMW/r0
  vm2=vmax**2
  vmrm=vmax*RMW
  alp=1.0/(p(1,1,1)-plim)
  a2m=vm2*((-0.5*bm0+0.25*bm1*(gam**2)-0.5*bm2*(gam**4))  &
  &         +(gam**(2.0*bt))*(0.5*bm0-0.25*bm1+0.5*bm2))
  b2m=vmrm*(-(bm1-bm3*(gam**2))+(bm1-bm3)*(gam**(bt-1.0)))
 
!$omp parallel default(shared)
!$omp do schedule(runtime) private(i,xm2,xm,x0)

  do i=1,nr
     xm=rz(i)/RMW
     x0=rz(i)/r0
     xm2=xm**2
     if(rz(i)<RMW)then  ! 꼰 A1, B1 ʬ, A2, B2 ʬ.
                        ! Ⱦ¤˱Ƥɤ餫.
        a1(i)=vm2*(xm2*(0.5-0.125*(x0**2)+(x0**4)/6.0)  &
  &                -0.5+0.125*(gam**2)-(gam**4)/6.0)
        b1(i)=vmrm*(xm2*(0.5-0.25*(x0**2))-0.5+0.25*(gam**2))
     else if(rz(i)<=r0.and.rz(i)>=RMW)then
        a1(i)=vm2*((xm**(-2.0*bt))*(-0.5*bm0+0.25*bm1*(x0**2)  &
  &                                 -0.5*bm2*(x0**4))  &
  &                +(gam**(2.0*bt))*(0.5*bm0-0.25*bm1+0.5*bm2))
        b1(i)=vmrm*(-(xm**(1.0-bt))*(bm1-bm3*(x0**2))  &
  &                 +(bm1-bm3)*(gam**(bt-1.0)))
     end if
     if(rz(i)<=RMW)then
        vr0(i)=vmax*xm*(1.0-x0**2)
     else if(rz(i)>RMW.and.rz(i)<r0)then
        vr0(i)=vmax*(xm**(-bt))*(1.0-x0**2)
     else
        vr0(i)=0.0
     end if

  end do

!$omp end do

!$omp barrier

!$omp do schedule(runtime) private(k)

  do k=1,nz
     if(p(1,1,k)>=plim)then
        GP(k)=alp*(p(1,1,k)-plim)
     else
        GP(k)=0.0
     end if
  end do

!$omp end do

!$omp barrier

!$omp do schedule(runtime) private(k)

!-- ǥ󥰥ǡĶγѿ׻.
  do k=1,nz
     qvbar(k)=rh(1,1,k)
     tempbar(k)=temp(1,1,k)
  end do

!$omp end do

!$omp barrier

!-- rz - z ɸ Peng et al 1999 Ƿ׻.
!-- ηϤαľɸ p ɸǤ뤳Ȥ.
!$omp do schedule(runtime) private(i,k)
  do k=1,nz
     do i=1,nr
        if(rz(i)<=RMW)then
           zr(i,k)=z(1,1,k)+((GP(k)**2)*(a2m+a1(i))+cor*GP(k)*(b2m+b1(i)))/g
           tempz(i,k)=tempbar(k)-(2.0*p(1,1,k)*alp/Rd)  &
  &                             *(GP(k)*(a2m+a1(i))+0.5*cor*(b2m+b1(i)))
        else if(rz(i)>RMW.and.rz(i)<=r0)then
           zr(i,k)=z(1,1,k)+((GP(k)**2)*a1(i)+cor*GP(k)*b1(i))/g
           tempz(i,k)=tempbar(k)-(2.0*p(1,1,k)*alp/Rd)  &
  &                             *(GP(k)*a1(i)+0.5*cor*b1(i))
        else
           zr(i,k)=z(1,1,k)
           tempz(i,k)=tempbar(k)
        end if
        vrz(i,k)=GP(k)*vr0(i)
     end do
  end do
!$omp end do
!$omp end parallel

  write(*,*) "Finished calculating thermodynamic values for r-z."

!-- ǥȺɸϤγʻ r ɽ,  r  rz ǤޤԤ

!$omp parallel default(shared)
!$omp do private(i,j,k,irz)
  do j=1,ny
     do i=1,nx
        call interpo_search_1d( rz, r(i,j), irz )
        do k=1,nz
           call interpolation_1d( rz(irz:irz+1), vrz(irz:irz+1,k),  &
  &                               r(i,j), vr(i,j,k))
           call interpolation_1d( rz(irz:irz+1), zr(irz:irz+1,k),  &
  &                               r(i,j), z(i,j,k))
           call interpolation_1d( rz(irz:irz+1), tempz(irz:irz+1,k),  &
  &                               r(i,j), temp(i,j,k))
           p(i,j,k)=p(1,1,k)
           rh(i,j,k)=qvbar(k)
        end do
     end do
  end do
!$omp end do
!$omp end parallel

  if(ubar/=0.0)then

write(*,*) "z check", z(nx/2,1:ny,1)
!-- ʿѾȤ簵ήɲä.
!-- (1) ǺΩˤĤƤιپοʿۤ¸.
!$omp parallel default(shared)
!$omp do private(k)
     do k=1,nz
        call grad_2d( xd, yd, z(:,:,k), dpdx(:,:,k), dpdy(:,:,k) )
     end do
!$omp end do

!$omp barrier

!-- (2) Ū˱ʤˤ, 簵ϹХ󥹤褦
!       پ, θ̤¸.
!       ΤȤǮϳؾϻѤʤ. ̤Τ߻Ѥ.
!       ܥץϱľɸϤǤ뤿, ̾Ǥβ٤ϰ.
!$omp do private(i,j,k)
     do k=1,nz
        do j=1,ny
           do i=1,nx
              pbar(i,j,k)=z(1,1,k)-cor*ubar*y(j)/g
           end do
        end do
     end do
!$omp end do

!$omp barrier

!-- (3) پζָۤ­碌.
!$omp do private(i,j,k)
     do k=1,nz
        do j=1,ny
           do i=1,nx
              dpdy(i,j,k)=dpdy(i,j,k)-cor*ubar/g
           end do
        end do
     end do
!$omp end do

!$omp barrier

!-- (4) ָۤ˴Ť, üپκƹ
!$omp do private(i,j,k)
     do k=1,nz
        do j=2,ny
           do i=1,nx
              if(j==2)then
                 z(i,j,k)=z(i,j-1,k)+dpdy(i,j-1,k)*dy
              else
                 z(i,j,k)=z(i,j-2,k)+dpdy(i,j-1,k)*2.0*dy
              end if
           end do
        end do
     end do
!$omp end do

!$omp barrier

!-- (5) Ʊ̤ˤ, ʿͿθۤδҸ̤֤.
!--     ˤоݤĤ.
!--     Ūˤ, ʿͿΥݥƥ󥷥٤η
!--     -cor*ubar/g ʤΤ, z(i,1,k)  z(i,jc,k) ʿͳθۤ
!--     -cor*ubar/g*(y(jc)-y(1)) Ȥʤ.
!--     ä, z(i,j,k)=z(i,j,k)+cor*ubar/g*(y(jc)-y(1)) ǿʿͤѤ.
!--     Ҹ˥ݥƥ󥷥 (оΤˤ).
!$omp do private(i,j,k)
     do k=1,nz
        do j=1,ny
           do i=1,nx
              z(i,j,k)=z(i,j,k)+cor*ubar*(yc-y(1))/g
           end do
        end do
     end do
!$omp end do
!$omp end parallel

  end if

!-- ǡǥȥǡؤѴ
!$omp parallel default(shared)
!$omp do private(i,j,k)
  do i=1,nz
     do j=1,ny
        do k=1,nx
          u(k,j,i) = -vr(k,j,i)*sin(theta(k,j))+ubar
          v(k,j,i) = vr(k,j,i)*cos(theta(k,j))
        end do
     end do
  end do
!$omp end do
!$omp end parallel

  write(*,*) "Finished converting Cartesian coordinates for each value."

  call DIRECT_3D_WRITE( trim(output_name), nx, ny, nz, z, u, v, p, temp, rh )
  call FORMAT_CTL( trim(output_name), nx, ny, nz, xd, yd, z(1,1,1:nz) )

  write(*,*) "Finish."
  write(*,*) "[NOTE1] : Thermodynamic values are TEMP and QV."
  write(*,*) "[NOTE2] : dx, dy, dz = ", dx, dy, dz, "[m]."

end program main

