program main

  use file_operate
  use Thermo_Const
  use Thermo_Function
  use Thermo_Advanced_Routine
  use Math_Const
  use Phys_Const
  use basis
  use Statistics
  use Typhoon_Analy
  use Max_min

  use sub_mod

!-- ؤ˽簵ήä۲ǡץ.
!--  (1) ʿήαľϥ,
!--  (2) ưϽవ, 
!--  (3) ʿήϹήХ.
!-- ΤȤ, ư \bar{\rho} fk\times u = -\nabla p,
!-- 弰դϰͤʤΤ, Ϳʿή®٤ȴܾ̩٤
!-- ʿ̤Ǥΰʬۤ
!-- p(x,y) = p_0 + \bar{\rho} f [v(x-x_0)-u(y-y_0)].
!-- p_0 ϴవ, x_0, y_0 ϤΰϤȤ.
!-- ư̩٤ϴܾʤΤ, ʿͤǤ.

  implicit none
  integer :: i, j, k, nl, nc, irz, ip

  real, parameter :: undefs=-999.0, undefc=-1.0e35
  real :: dx, dy, dz  ! x, y, z γʻֳ [m]
  real :: xc, yc
  real :: rmax  ! region distance from center
  real, allocatable, dimension(:) :: x, y    ! ǥȺɸ׻
  real, allocatable, dimension(:) :: xd, yd  ! ǥȺɸϿ
  real, allocatable, dimension(:) :: rz  ! ɸ
  real, allocatable, dimension(:) :: rho  ! ̩٤Υǥ
  real, allocatable, dimension(:) :: ebar, ptv, rhobar, tempbar, qvbar, prev
  real, allocatable, dimension(:,:) :: ptvp, ep, Buo
  real, allocatable, dimension(:,:) :: r, theta  ! ɸ
  real, allocatable, dimension(:,:) :: vrz, pz, rhoz, tempz, qvz  ! ɸ
  real, allocatable, dimension(:,:) :: coril  ! ꥪѥ᡼
  real, allocatable, dimension(:,:) :: sonde_val  ! sounding value
  real, allocatable, dimension(:,:,:) :: u, v, w, p, temp, rh, vr, z, ptp
        ! 줾, , ľ, , , RH, ®,  (MKS)
  real, allocatable, dimension(:,:,:) :: dpdx, dpdy, dtdx, dtdy, dtbdy
  real, allocatable, dimension(:,:,:) :: pbar, tbar

  character(100), allocatable, dimension(:,:) :: tmp_val  ! եɤ߽Ф

!-- temporary
!  real, allocatable, dimension(:) :: r2
!  real, allocatable, dimension(:,:,:) :: vr2, vt2, temp2, rh2, p2
!  real, allocatable, dimension(:,:,:) :: sst, z2
!  real, allocatable, dimension(:,:,:) :: tmp1
!  real, allocatable, dimension(:,:) :: tmp2

!-- namelist values
  integer :: nx, ny, nz, nr
  integer :: skip_num
  real :: xmin, xmax, ymin, ymax, zmin, zmax
  real :: rc, Bmax, zlim, cent_lat, qvrh, qvzh, qvmax, ubar
  real :: ptmax, ptxc, ptyc, ptzc, ptxr, ptyr, ptzr
  character(100) :: sounding_name, output_name, read_colum
  character(5), dimension(4) :: unit_flag

!-- reading namelist

  namelist /input /xmin, ymin, zmin, xmax, ymax, zmax, nx, ny, nz, nr
  namelist /param /rc, Bmax, zlim, cent_lat, qvrh, qvzh, qvmax, ubar
  namelist /inifo /ptmax, ptxc, ptyc, ptzc, ptxr, ptyr, ptzr
  namelist /fread /sounding_name, skip_num, read_colum, unit_flag, output_name

  read(5,nml=input)
  read(5,nml=param)
  read(5,nml=inifo)
  read(5,nml=fread)

  write(*,*) "Finished reading namelist."

!-- allocatable

  allocate(x(nx))
  allocate(y(ny))
  allocate(xd(nx))
  allocate(yd(ny))
  allocate(r(nx,ny))
  allocate(theta(nx,ny))
  allocate(u(nx,ny,nz))
  allocate(v(nx,ny,nz))
  allocate(w(nx,ny,nz))
  allocate(p(nx,ny,nz))
  allocate(temp(nx,ny,nz))
  allocate(rh(nx,ny,nz))
  allocate(z(nx,ny,nz))
  allocate(ptp(nx,ny,nz))
  allocate(vr(nx,ny,nz))
  allocate(dpdx(nx,ny,nz))
  allocate(dpdy(nx,ny,nz))
  allocate(dtdx(nx,ny,nz))
  allocate(dtdy(nx,ny,nz))
  allocate(dtbdy(nx,ny,nz))
  allocate(pbar(nx,ny,nz))
  allocate(tbar(nx,ny,nz))
  allocate(rz(nr))
  allocate(vrz(nr,nz))
  allocate(pz(nr,nz))
  allocate(rhoz(nr,nz))
  allocate(tempz(nr,nz))
  allocate(qvz(nr,nz))
  allocate(Buo(nr,nz))
  allocate(ep(nr,nz))
  allocate(ptvp(nr,nz))
  allocate(coril(nr,nz))
  allocate(rho(nz))
  allocate(ebar(nz))
  allocate(ptv(nz))
  allocate(rhobar(nz))
  allocate(tempbar(nz))
  allocate(qvbar(nz))
  allocate(prev(nz))

!  allocate(sst(nx,ny,1))
!  allocate(tmp1(nx,ny,nz))
!  allocate(tmp2(nx,ny))
!  allocate(temp2(-1:nx,2,nz))
!  allocate(vr2(-1:nx,2,nz))
!  allocate(vt2(-1:nx,2,nz))
!  allocate(rh2(-1:nx,2,nz))
!  allocate(p2(-1:nx,2,nz))
!  allocate(z2(-1:nx,2,nz))
!  allocate(r2(-1:nx))

!-- parameter setting
  dx=(xmax-xmin)/(nx-1)
  dy=(ymax-ymin)/(ny-1)
  dz=(zmax-zmin)/(nz-1)

  xd=(/((xmin+dx*(i-1)),i=1,nx)/)
  yd=(/((ymin+dy*(i-1)),i=1,ny)/)

  xc=0.5*(xmin+xmax)
  yc=0.5*(ymin+ymax)

  do i=1,nx
     x(i)=xd(i)-xc
  end do
  do i=1,ny
     y(i)=yd(i)-yc
  end do

!  r2=(/((dx*(i-1)),i=-1,nx)/)
!  r2(-1:0)=0.0

!-- ꥪѥ᡼׻
  coril=2.0*omega*sin(cent_lat*pi/180.0)

!-- ˺ɸؤѴ
  do j=1,ny
    do i=1,nx 
      r(i,j)=sqrt(x(i)**2+y(j)**2)
    end do
  end do

  do j=1,ny
    do i=1,nx 
      if(x(i)==0.0)then
        if(y(j)==0.0)then
          theta(i,j)=0.0
        else
          if(y(j)<0.0)then
            theta(i,j)=-atan(1.0)*2.0
          else
            theta(i,j)=atan(1.0)*2.0
          end if
        end if
      else
        if(y(j)>0.0)then
          if(x(i)>0.0)then
            theta(i,j)=atan(y(j)/x(i))
          else
            theta(i,j)=atan(1.0)*4.0-atan(abs(y(j)/x(i)))
          end if
        else
          if(x(i)>0.0)then
            theta(i,j)=atan(y(j)/x(i))
          else
            theta(i,j)=-atan(1.0)*4.0+atan(abs(y(j)/x(i)))
          end if
        end if
      end if
    end do
  end do

!-- SST  ---
!  sst(:,1:ny/2,1) = 273.0+30.5
!  sst(:,ny/2+1:ny,1) = 273.0+29.5

!-- sst ν񤭽Ф ---
!  call DIRECT_2D_WRITE( 'data.sst.bin', nx, ny, sst )
!  deallocate(sst)


!-- ɸν񤭽Ф ---
!  tmp1 = -0.1
!  tmp2 = -0.1
!  call DIRECT_2D_WRITE( 'data.terrain.bin', nx, ny, tmp2 )
!  deallocate(tmp2)

!-- ٤ν񤭽Ф ---
  do i=1,nz
     do j=1,ny
        do k=1,nx
           z(k,j,i) = zmin+dz*(i-1)
        end do
     end do
  end do

  call max_val_2d( r, j, k, rmax )
  rz=(/((real(i-1)*rmax/real(nr-1)),i=1,nr)/)

  write(*,*) "Finished producing all coordinates."

!-- Ǯϳѿɤ߹ߡʥǥ󥰥ǡΤߡ ---
  nl=line_number_counter( trim(sounding_name) )
  nl=nl-skip_num
  nc=len_trim(adjustl(read_colum))

  allocate(tmp_val(nc,nl))
  allocate(sonde_val(nl,4))

  call read_file_text( trim(sounding_name), nc, nl, tmp_val, skip=skip_num )

!-- ǡ֤ ---

  do k=1,nc
     select case (read_colum(k:k))
     case ('1')  ! ٤
        do j=1,nl
           sonde_val(j,1)=c2r_convert( trim(adjustl(tmp_val(k,j))) )
        end do
     case ('2')  ! 
        do j=1,nl
           sonde_val(j,2)=c2r_convert( trim(adjustl(tmp_val(k,j))) )
        end do
     case ('3')  ! ٤
        do j=1,nl
           sonde_val(j,3)=c2r_convert( trim(adjustl(tmp_val(k,j))) )
        end do
     case ('4')  ! ̤
        do j=1,nl
           sonde_val(j,4)=c2r_convert( trim(adjustl(tmp_val(k,j))) )
        end do
     end select
  end do

!-- ٳʻɬפʥǡ

  !-- , Ǥιٺɸñ̤ m ѴƤ.
  if(trim(unit_flag(1))=='km')then
     do i=1,nl
        sonde_val(i,1)=sonde_val(i,1)*1.0e3
     end do
  end if

  call auto_interpolation_1d( sonde_val(1:nl,1), z(1,1,1:nz),  &
  &                           sonde_val(1:nl,2), p(1,1,1:nz),  &
  &                           undef=undefc, undefr=undefs )  ! 

  call auto_interpolation_1d( sonde_val(1:nl,1), z(1,1,1:nz),  &
  &                           sonde_val(1:nl,3), temp(1,1,1:nz),  &
  &                           undef=undefc, undefr=undefs )  ! 

  call auto_interpolation_1d( sonde_val(1:nl,1), z(1,1,1:nz),  &
  &                           sonde_val(1:nl,4), rh(1,1,1:nz),  &
  &                           undef=undefc, undefr=undefs )  ! 

!-- ñ̤Ĵ (, , ٤ m, Pa, K, %)

  if(trim(unit_flag(2))=='mb'.or.trim(unit_flag(2))=='hPa')then
     do k=1,nz
        if(p(1,1,k)/=undefc)then
           p(1,1,k)=p(1,1,k)*1.0e2
        end if
        prev(k)=-p(1,1,k)
     end do
  end if

  if(trim(unit_flag(3))=='C')then
     do k=1,nz
        if(temp(1,1,k)/=undefc)then
           temp(1,1,k)=temp(1,1,k)+273.15
        end if
     end do
  end if

  if(trim(unit_flag(4))=='%')then
     do k=1,nz
        if(rh(1,1,k)/=undefc)then
           rh(1,1,k)=RHTP_2_qv( rh(1,1,k), temp(1,1,k), p(1,1,k) )
        end if
     end do
  else if(trim(unit_flag(4))=='gkg')then
     do k=1,nz
        if(rh(1,1,k)/=undefc)then
           rh(1,1,k)=rh(1,1,k)*1.0e-3
        end if
     end do
  end if

  write(*,*) "Finished reading sounding data and converting units."

!-- ǥ󥰥ǡĶγѿ׻.
  do k=1,nz
     ebar(k)=exner_func_dry( p(1,1,k) )
     ptv(k)=TqvP_2_thetav( temp(1,1,k), rh(1,1,k), p(1,1,k) )
     qvbar(k)=rh(1,1,k)
     tempbar(k)=temp(1,1,k)
     rhobar(k)=TP_2_rho( tempbar(k), p(1,1,k) )
  end do

!-- rz - z ɸ Montgomery et al 2006  (2), (3), (4) ׻.
!-- ϥŪͿ, ĶȥΥޥ¤Ƿ׻.
  do k=1,nz
     do i=1,nr
        Buo(i,k)=Buo_func( Bmax, rc, rz(i), z(1,1,k), zlim )
        ep(i,k)=exner_pert( Bmax, rc, rz(i), z(1,1,k), zlim )
        vrz(i,k)=v0( coril(i,k), rc, rz(i), ptv(k), ep(i,k) )
        if(z(1,1,k)<=zlim)then
           qvz(i,k)=qvbar(k)  &
  &                +qvmax*exp(-(log(2.0)*((rz(i)/qvrh)**2+(z(1,1,k)/qvzh)**2)))
        else
           qvz(i,k)=qvbar(k)
        end if
     end do
  end do

!-- ®ȴĶΰ, ̩٤Ȥ, rz - z ̤ΰϤ̩٤׻.

!  call hydro_grad_eqb( rz, z(1,1,:), coril, vrz, p(1,1,:), rhobar(:),  &
!  &                    pz, rhoz )

!-- (2), (3), (4) 鵤, ,  rz - z ʬۤ׻.
!-- κ, ʡؿϴĶͤ (3) ¤ȤƷ׻,
!-- ٤Ͼη׻줿Ȳ̾줫׻.

  do k=1,nz
     do i=1,nr
        ptvp(i,k)=Buo(i,k)*ptv(k)*ptv(k)*Cpd/g  ! к (B=g*ptv'/Cp/ptv**2)
        pz(i,k)=p0*((ebar(k)+ep(i,k))**(Cpd/Rd))  ! ʡؿεջ
        tempz(i,k)=thetavqvP_2_T( ptv(k)+ptvp(i,k), qvz(i,k), pz(i,k) )
        if(qvz(i,k)>30.0e-3)then
           write(*,*) "[WARN] : qv value is abnormally.", i, k
           write(*,*) "qv, T, ptv, pres", qvz(i,k), tempz(i,k), ptv(k), ptvp(i,k), pz(i,k)
           write(*,*) "value check", ptv(k), theta_dry( tempz(i,k), pz(i,j) )
        end if
     end do
  end do 

  write(*,*) "Finished calculating thermodynamic values for r-z."

!-- ǥȺɸϤγʻ r ɽ,  r  rz ǤޤԤ

!$omp parallel default(shared)
!$omp do private(i,j,k,irz)
  do j=1,ny
     do i=1,nx
        call interpo_search_1d( rz, r(i,j), irz )
        do k=1,nz
           call interpolation_1d( rz(irz:irz+1), vrz(irz:irz+1,k),  &
  &                               r(i,j), vr(i,j,k))
           call interpolation_1d( rz(irz:irz+1), pz(irz:irz+1,k),  &
  &                               r(i,j), p(i,j,k))
           call interpolation_1d( rz(irz:irz+1), tempz(irz:irz+1,k),  &
  &                               r(i,j), temp(i,j,k))
           call interpolation_1d( rz(irz:irz+1), qvz(irz:irz+1,k),  &
  &                               r(i,j), rh(i,j,k))
        end do
     end do
  end do
!$omp end do

!$omp barrier

!-- ǥȥǡȤʤäǮϳʪ̤ˤĤ, ̥Х֥ꤹ.
!$omp do private(i,j,k)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           ptp(i,j,k)=make_ptp( x(i), y(j), z(i,j,k), ptmax,  &
  &                             ptxc, ptyc, ptzc,  &
  &                             ptxr, ptyr, ptzr )
           ptp(i,j,k)=ptp(i,j,k)+theta_dry( temp(i,j,k), p(i,j,k) )
           temp(i,j,k)=thetaP_2_T( ptp(i,j,k), p(i,j,k) )
        end do
     end do
  end do
!$omp end do

!$omp barrier

!-- ʿѾȤ簵ήɲä.
!-- (1) ǺΩˤĤƤβ, Ͼοʿۤ¸.
!$omp do private(k)
  do k=1,nz
     call grad_2d( xd, yd, p(:,:,k), dpdx(:,:,k), dpdy(:,:,k) )
     call grad_2d( xd, yd, temp(:,:,k), dtdx(:,:,k), dtdy(:,:,k) )
  end do
!$omp end do

!$omp barrier

!-- (2) Ū˱ʤˤ, 簵ϹХ󥹤褦
!       Ȳپ, θ̤¸.
!       ΤȤǮϳؾϻѤʤ. ̤Τ߻Ѥ.
!$omp do private(i,j,k,ip)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           pbar(i,j,k)=p(1,1,k)  &
  &                   -coril(1,1)*ubar*TP_2_rho( temp(1,1,k), p(1,1,k) )*y(j)
           call interpo_search_1d( prev(1:nz), -pbar(i,j,k), ip )
           if(ip<1)then
              tbar(i,j,k)=temp(i,j,1)
           else if(ip==nz)then
              tbar(i,j,k)=temp(i,j,nz)
           else
              call interpolation_1d( p(1,1,ip:ip+1), temp(1,1,ip:ip+1),  &
  &                                  pbar(i,j,k), tbar(i,j,k) )
           end if
        end do
     end do
  end do
!$omp end do

!$omp barrier

!$omp do private(i,k)
  do k=1,nz
     do i=1,nx
        call grad_1d( yd, tbar(i,:,k), dtbdy(i,:,k) )
     end do
  end do
!$omp end do

!$omp barrier

!-- (3) Ǯϳؾζָۤ­碌.
!$omp do private(i,j,k)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           dpdy(i,j,k)=dpdy(i,j,k)-coril(1,1)*ubar*TP_2_rho( temp(1,1,k), p(1,1,k) )
           dtdy(i,j,k)=dtdy(i,j,k)+dtbdy(i,j,k)
        end do
     end do
  end do
!$omp end do

!$omp barrier

!-- (4) ָۤ˴Ť, ü鲹, κƹ
!$omp do private(i,j,k)
  do k=1,nz
     do j=2,ny
        do i=1,nx
           if(j==2)then
              p(i,j,k)=p(i,j-1,k)+dpdy(i,j-1,k)*dy
              temp(i,j,k)=temp(i,j-1,k)+dtdy(i,j-1,k)*dy
           else
              p(i,j,k)=p(i,j-2,k)+dpdy(i,j-1,k)*2.0*dy
              temp(i,j,k)=temp(i,j-2,k)+dtdy(i,j-1,k)*2.0*dy
           end if
        end do
     end do
  end do
!$omp end do

!$omp barrier

!-- (5) Ʊ̤ˤ, ʿͿθۤδҸ̤֤.
!--     ˤоݤĤ.
!--     Ūˤ, ʿͿΰϤη
!--     -cor*ubar*rhob ʤΤ, p(i,1,k)  p(i,jc,k) ʿͳθۤ
!--     -cor*ubar*rhob*(y(jc)-y(1)) Ȥʤ.
!--     ä, p(i,j,k)=p(i,j,k)+cor*ubar*rhob*(y(jc)-y(1)) ǿʿͤѤ.
!--     Ҹ˰Ϥ (оΤˤ).
!--     ǤϲپѤʤ. ʤʤ, ϤʿͤѤΤ,
!--     ʬۤ⾯Ѳ뤬, Ѳ, ͤѤ뤿,
!--     θʤ. 줬.
!$omp do private(i,j,k)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           p(i,j,k)=p(i,j,k)+coril(1,1)*ubar*TP_2_rho(temp(1,1,k), p(1,1,k))*(yc-y(1))
        end do
     end do
  end do
!$omp end do

!$omp barrier

!-- (5) ⤦ٰ, پˤĤ x ζָۤ׻,
!       θۤѲƤʤå
!$omp do private(j,k)
  do k=1,nz
     do j=1,ny
        call grad_1d( xd, p(:,j,k), dpdy(:,j,k) )  ! λȤޤ路 (x ʬ).
        call grad_1d( xd, temp(:,j,k), dtdy(:,j,k) )  ! λȤޤ路 (x ʬ).
     end do
  end do
!$omp end do

!$omp barrier

!$omp do private(i,j,k)
  do k=1,nz
     do j=1,ny
        do i=1,nx
           dpdx(i,j,k)=dpdx(i,j,k)-dpdy(i,j,k)
           dtdx(i,j,k)=dtdx(i,j,k)-dpdy(i,j,k)
!           if((abs(dpdx(i,j,k))>abs(dpdy(i,j,k))).and.(abs(dpdy(i,j,k))/=0.0))then  ! 2 Ԥκͤ礭, å.
!              write(*,*) "Detect dpdx", dpdx(i,j,k), abs(dpdy(i,j,k))
!           end if
!           if((abs(dtdx(i,j,k))>abs(dtdy(i,j,k))).and.(abs(dtdy(i,j,k))/=0.0))then  ! 2 Ԥκͤ礭, å.
!              write(*,*) "Detect dtdx", dtdx(i,j,k), abs(dtdy(i,j,k))
!           end if
        end do
     end do
  end do
!$omp end do

!$omp barrier

!-- ǡǥȥǡؤѴ
!$omp do private(i,j,k)
  do i=1,nz
     do j=1,ny
        do k=1,nx
          u(k,j,i) = -vr(k,j,i)*sin(theta(k,j))+ubar
          v(k,j,i) = vr(k,j,i)*cos(theta(k,j))
        end do
     end do
  end do
!$omp end do
!$omp end parallel

  write(*,*) "Finished converting Cartesian coordinates for each value."

!     call grad_win_pres( nx, ny, naisou_val, f0, vc, rc, zlim, Rd, temp(1,1,i), z(1,1,i), x, y, p(:,:,i) )
!     do k=-1,nx
!     p2(k,:,i)=naisou_val*100.0
!     end do

!  end do

  call DIRECT_3D_WRITE( trim(output_name), nx, ny, nz, z, u, v, p, temp, rh )
  call FORMAT_CTL( trim(output_name), nx, ny, nz, xd, yd, z(1,1,1:nz) )

  write(*,*) "Finish."
  write(*,*) "[NOTE1] : Thermodynamic values are TEMP and QV."
  write(*,*) "[NOTE2] : dx, dy, dz = ", dx, dy, dz, "[m]."

end program main

