#!/usr/bin/bash
# Author: Satoki Tsujino (satoki_at_gfd-dennou.org)
#------------- Setting the latest STPK version --------------
Ver=0.9.20.0  # You can check the latest version on the official website (https://www.gfd-dennou.org/library/davis/stpk/)
fc=ifort  # Intel Fortran (you can choose other compilers)
flags="-assume byterecl -convert big_endian"  # You need to set options for the endian, depending on "fc"
#------------------------------------------------------------

wdir=`pwd`

export FC=$fc
export FCFLAGS=$flags

rm -r libstpk-* include lib
make clean

wget https://www.gfd-dennou.org/library/davis/stpk/download/libstpk-"$Ver".tar.gz
tar zxvf libstpk-"$Ver".tar.gz

cd libstpk-"$Ver"
./configure --prefix=$wdir --includedir="$wdir"/include
make
make install
cd ../

cp Mkinclude.template Mkinclude
grep -l '<fc>' Mkinclude | xargs sed -i.bak -e "s/<fc>/$fc/g"
grep -l '<flags>' Mkinclude | xargs sed -i.bak -e "s/<flags>/$flags/g"
grep -l '<stpklib>' Mkinclude | xargs sed -i.bak -e "s#<stpklib>#$wdir#g"  # using # as the splitting character
make
