module sub_mod

  use basis
  use Math_Const

  implicit none

  real, parameter :: alpha=0.2
  real, parameter :: beta=1.0

contains

real function make_ptp( x, y, z, ptmax, ptxc, ptyc, ptzc, ptxr, ptyr, ptzr )
  ! Ѵؿλʱߵ巿β̾Ϳؿ.
  ! Ǥ, Ĺ, 漴, ûʱߵ
  ! ʱߵ̤̤̤Ȥʤ褦ʱߵͤ.
  ! ̤ Lx, Ly, Lz, 濴 x0, y0, z0 ȤȤ,
  ! Ǥդ x, y, z ˤ벹̤ưͤ濴Ǥκк ptm ȤȤ,
  ! pt(x,y,z)=ptm*cos((pi/2)*r), (r<=1)
  ! pt(x,y,z)=0, (r>1)
  ! , r=sqrt((x-x0)**2/Lx**2+(y-y0)**2/Ly**2+(z-z0)**2/Lz**2)
  ! ʤʤ, ƼĹ Lx, Ly, Lz ʱߤʱߵ夬̤Ȥʤ
  ! 褤Τ, x**2/Lx**2+y**2/Ly**2+z**2/Lz**2=1 ȤʤʱߵˤĤ,
  ! 濴Ʊ x'**2/a**2+y'**2/b**2+z'**2/c**2=1 ɽǤ.
  ! ΤȤ, ƼϸεĹȰǴطդ.
  ! Ĥޤ,  u Ѥ, a=uLx, b=uLy, c=uLz Ǥ.
  ! ä,  x'**2/Lx**2+y'**2/Ly**2+z'**2/Lz**2=u**2
  ! ɽ뤳ȤǤ. ä, Lx, Ly, Lz ʱߵ̤ʪ F Υ
  ! ǤäȤ, ʪ F λѴؿλʱߵʬۤ
  ! F=cos((pi/2)*u) ɽ뤳ȤǤ. , a,b,c ɽ
  ! Ʊʱߵ Lx. Ly, Lz ⾮ΤȲꤷƤ.
  ! Ĥޤ, Ʊʱߵ濴նǤ u~0 Ȥʤ.
  implicit none
  real, intent(in) :: x     ! кͿ x ɸ [m]
  real, intent(in) :: y     ! кͿ y ɸ [m]
  real, intent(in) :: z     ! кͿ z ɸ [m]
  real, intent(in) :: ptmax ! кκ [K]
  real, intent(in) :: ptxc  ! к濴ɸ x [m]
  real, intent(in) :: ptyc  ! к濴ɸ y [m]
  real, intent(in) :: ptzc  ! к濴ɸ z [m]
  real, intent(in) :: ptxr  ! к 1/4 Ĺ x  [m]
  real, intent(in) :: ptyr  ! к 1/4 Ĺ y  [m]
  real, intent(in) :: ptzr  ! к 1/4 Ĺ z  [m]
  ! 1/4 ĹʱߵĹ, 漴, ûĹɽ.
  real :: rp

!-- x,y,z ƶȾ¸ߤ뤫Ƚ.
  rp=sqrt(((x-ptxc)/ptxr)**2+((y-ptyc)/ptyr)**2+((z-ptzc)/ptzr)**2)

  if(rp<1.0)then
     make_ptp=ptmax*cos(0.5*pi*rp)
  else
     make_ptp=0.0
  end if

end function make_ptp

real function Buo_func( Bmax, a, r, z, H )  ! 
  implicit none
  real, intent(in) :: Bmax  ! Ϥκ
  real, intent(in) :: a     ! ®Ⱦ [m]
  real, intent(in) :: r     ! 濴Ⱦ [m]
  real, intent(in) :: z     !  [m]
  real, intent(in) :: H     ! ®٤ 2  [m]

  if(z<=H)then
     Buo_func=Bmax*a*a*(alpha*sin(pi*z/H)-beta*sin(2.0*pi*z/H))/(a*a+r*r)
  else
     Buo_func=0.0
  end if

  return

end function Buo_func

real function exner_pert( Bmax, a, r, z, H )  ! ʡؿư
  implicit none
  real, intent(in) :: Bmax  ! Ϥκ
  real, intent(in) :: a     ! ®Ⱦ [m]
  real, intent(in) :: r     ! 濴Ⱦ [m]
  real, intent(in) :: z     !  [m]
  real, intent(in) :: H     ! ®٤ 2  [m]

  if(z<=H)then
     exner_pert=Bmax*a*a*H*(-alpha*(cos(pi*z/H)+1.0)  &
  &                         +0.5*beta*(cos(2.0*pi*z/H)-1.0))  &
  &             /((a*a+r*r)*pi)
  else
     exner_pert=0.0
  end if

  return

end function exner_pert

real function v0( cor, a, r, ptv, ep )  ! η׻
  use Thermo_Const
  implicit none
  real, intent(in) :: cor   ! ꥪѥ᡼ [s-1]
  real, intent(in) :: a     ! ®Ⱦ [m]
  real, intent(in) :: r     ! 濴Ⱦ [m]
  real, intent(in) :: ptv   ! ܾβ [K]
  real, intent(in) :: ep    ! exner ؿư [1]

  v0=-0.5*cor*r+sqrt(0.25*((cor*r))**2-2.0*r*r*ptv*Cpd*ep/(a*a+r*r))

  return

end function v0

subroutine DIRECT_3D_WRITE( filename, nmax, mmax, lmax, z, u, v, p, temp, &
  &  qv )
  implicit none
  character(*), intent(in) :: filename
  integer :: i, j, k
  integer, intent(in) :: nmax, mmax, lmax
  real, intent(in), dimension(nmax,mmax,lmax) :: z, u, v, p, temp, qv
  integer :: sized, max_rec

  sized=nmax*mmax*4
  max_rec=0

   open(unit=14,file=filename,access='direct',recl=sized,status="unknown")
     do k=1,lmax
        write(14,rec=k) ((z(i,j,k),i=1,nmax),j=1,mmax)
     end do
     max_rec=max_rec+lmax
     do k=1,lmax
        write(14,rec=max_rec+k) ((u(i,j,k),i=1,nmax),j=1,mmax)
     end do
     max_rec=max_rec+lmax
     do k=1,lmax
        write(14,rec=max_rec+k) ((v(i,j,k),i=1,nmax),j=1,mmax)
     end do
     max_rec=max_rec+lmax
     do k=1,lmax
        write(14,rec=max_rec+k) ((p(i,j,k),i=1,nmax),j=1,mmax)
     end do
     max_rec=max_rec+lmax
     do k=1,lmax
        write(14,rec=max_rec+k) ((temp(i,j,k),i=1,nmax),j=1,mmax)
     end do
     max_rec=max_rec+lmax
     do k=1,lmax
        write(14,rec=max_rec+k) ((qv(i,j,k),i=1,nmax),j=1,mmax)
     end do
   close(unit=14,status="keep")
  
end subroutine DIRECT_3D_WRITE

subroutine FORMAT_CTL( filename, nmax, mmax, lmax, x, y, z )
  implicit none
  character(*), intent(in) :: filename
  integer :: i, j, k, nc
  integer, intent(in) :: nmax, mmax, lmax
  real, intent(in) :: x(nmax), y(mmax), z(lmax)
  character(1000) :: tmpc, forma
  integer, parameter :: nv=16
  real :: dx, dy, dz

  dx=x(2)-x(1)
  dy=y(2)-y(1)
  dz=z(2)-z(1)

  write(*,*) "------------- GRADS CTL FILE TEMPLATE ------------"
  do i=1,nv
     select case (i)
     case (1)
        tmpc="dset "//trim(adjustl(filename))
     case (2)
        tmpc="title automatically generated storm structure in TC_Bogus (Satoki Tsujino)"
     case (3)
        tmpc="options big_endian"
     case (4)
        tmpc="undef 1.0E+35"
     case (5)
        tmpc="xdef "//trim(adjustl(i2c_convert(nmax)))//' LINEAR '  &
  &                 //trim(adjustl(r2c_convert(x(1))))//' '//trim(adjustl(r2c_convert(dx)))
     case (6)
        tmpc="ydef "//trim(adjustl(i2c_convert(mmax)))//' LINEAR '  &
  &                 //trim(adjustl(r2c_convert(y(1))))//' '//trim(adjustl(r2c_convert(dy)))
     case (7)
        tmpc="zdef "//trim(adjustl(i2c_convert(lmax)))//' LINEAR '  &
  &                 //trim(adjustl(r2c_convert(z(1))))//' '//trim(adjustl(r2c_convert(dz)))
     case (8)
        tmpc="tdef 1 LINEAR 00Z01JAN0000 06hr"
     case (9)
        tmpc="vars 6"
     case (10)
        tmpc="z "//trim(adjustl(i2c_convert(lmax)))//' 99 Height (m)'
     case (11)
        tmpc="u "//trim(adjustl(i2c_convert(lmax)))//' 99 X-component of horizontal wind (m/s)'
     case (12)
        tmpc="v "//trim(adjustl(i2c_convert(lmax)))//' 99 Y-component of horizontal wind (m/s)'
     case (13)
        tmpc="p "//trim(adjustl(i2c_convert(lmax)))//' 99 Pressure (Pa)'
     case (14)
        tmpc="t "//trim(adjustl(i2c_convert(lmax)))//' 99 Temperature (K)'
     case (15)
        tmpc="q "//trim(adjustl(i2c_convert(lmax)))//' 99 Water vapor mixing ratio (kg/kg)'
     case (16)
        tmpc="endvars"
     end select

     nc=len_trim(adjustl(tmpc))
     forma='(a'//trim(adjustl(i2c_convert(nc)))//')'
     write(*,trim(adjustl(forma))) tmpc(1:nc)
  end do

  write(*,*) "------------- GRADS CTL FILE TEMPLATE ------------"

end subroutine FORMAT_CTL

end module sub_mod
